
#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

#define cof(array) (sizeof(array) / sizeof(array[0]))

LPTSTR searchPaths[] = {
    _T("..\\lib\\"),
    _T(""),
    _T("lib\\"),
    _T("..\\"),
};

BOOL findJar(LPTSTR title, LPTSTR jarPath) {
    LPTSTR tail;
    TCHAR name[MAX_PATH + 256];
    {
        GetModuleFileName(NULL, jarPath, MAX_PATH);
        tail = _tcsrchr(jarPath, _T('\\'));
        if (tail != NULL) {
            tail++;
            _tcscpy(name, tail);
        } else {
            _tcscpy(name, jarPath);
            tail = jarPath;
        }
    }
    // name is the name of the excutable file.  E.g. "notavabuild.exe"
    // jarPath begins with the path of the file and tail points the next of the last '\\'.
    
    {
        // replace ".exe" with ".jar"
        LPTSTR q = _tcsrchr(name, _T('.'));
        if (q != NULL) {
            *q = _T('\0');
        } else {
            q = name + _tcslen(name);
        }
        _tcscpy(title, name);
        _tcscpy(q, _T(".jar"));
    }
    // name is the name of the jar file.  E.g. "notavabuild.jar"
    
    {
        int i = 0;
        for (; i < cof(searchPaths); i++) {
            _tcscpy(tail, searchPaths[i]);
            _tcscat(tail, name);
            if (GetFileAttributes(jarPath) != 0xFFFFFFFF)
                break;
        }
        
        if (i >= cof(searchPaths)) {
            _ftprintf(stderr, _T("error: %s not found.\n"), (LPCTSTR) name);
            return FALSE;
        }
    }
    return TRUE;
}

int bootJar(LPCTSTR title, LPCTSTR jarPath, LPCTSTR cmdline) {
    LPTSTR key = _tcsupr(_tcscpy((LPTSTR) _alloca(sizeof(TCHAR) * (_tcslen(title) + 256)), title));
    LPCTSTR options = _tgetenv(_tcscat(key, _T("_VMOPTIONS")));
    
    LPTSTR newCmdLine;
    int length;
    BOOL quoted = FALSE;
    for (; *cmdline != _T('\0'); cmdline++) {
        if (!quoted && _istspace(*cmdline))
            break;
        if (*cmdline == _T('\"')) {
            if (quoted) {
                quoted = FALSE;
            } else {
                quoted = TRUE;
            }
        }
    }
    length = _tcslen(jarPath) + _tcslen(cmdline);
    if (options != NULL)
        length += _tcslen(options);
    newCmdLine = (LPTSTR) _alloca(sizeof(TCHAR) * (length + 256));
    
    _tcscpy(newCmdLine, _T("java "));
    if (options != NULL) {
        _tcscat(newCmdLine, options);
        _tcscat(newCmdLine, _T(" "));
    }
    
    _tcscat(newCmdLine, _T("-jar "));
    _tcscat(newCmdLine, jarPath);
    _tcscat(newCmdLine, _T(" "));
    _tcscat(newCmdLine, cmdline);
    //printf("calling %s\n", newCmdLine);
    return _tsystem(newCmdLine);
}

int _tmain(int argc, TCHAR **argv) {
    TCHAR title[MAX_PATH + 1];
    TCHAR jarPath[MAX_PATH + 256];
    if (!findJar(title, jarPath))
        return -1;
    return bootJar(title, jarPath, GetCommandLine());
}

